# git clone https://github.com/lwfinger/rtl8192du
# git archive 
# add patch to select du against cu module

%global	module	8192du
%global pname rtl%{module}

Name:		dkms-%{pname}
Version:	4.0.10
Release:	%mkrel 1
Source0:	%{pname}-%{version}.tar.xz

Patch0:		rtl8192du-makefile.patch

License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/lwfinger/rtl8192du
Summary:	dkms package for realtek 8188/8192 du driver
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	%{name}-%{version}
Provides:	kmod(%{pname}.ko) = %{version}
Requires: 	kernel
Requires:   gcc >= 10.2.0
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	dkms-%{pname} < %{version}-%{release}

%description
/* DID_USB_v915_20121224 */
#define RTL8192D_USB_IDS \
	/*=== Realtek demoboard ===*/ \
	/****** 8192DU ********/ \
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8193)},/* 8192DU-VC */ \
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8194)},/* 8192DU-VS */ \
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8111)},/* Realtek 5G dongle for WiFi Display */ \
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x0193)},/* 8192DE-VAU */ \
{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8171)},/* 8192DU-VC */ \
	/*=== Customer ID ===*/ \
	/****** 8192DU-VC ********/ \
{USB_DEVICE(0x2019, 0xAB2C)},/* PCI - Abocm */ \
{USB_DEVICE(0x2019, 0x4903)},/* PCI - ETOP */ \
{USB_DEVICE(0x2019, 0x4904)},/* PCI - ETOP */ \
{USB_DEVICE(0x07B8, 0x8193)},/* Abocom - Abocom */ \
	/****** 8192DU-VS ********/ \
{USB_DEVICE(0x20F4, 0x664B)}, /* TRENDnet - Cameo */ \
{USB_DEVICE(0x04DD, 0x954F)},  /* Sharp */ \
{USB_DEVICE(0x04DD, 0x96A6)},  /* Sharp */ \
{USB_DEVICE(0x050D, 0x110A)}, /* Belkin - Edimax */ \
{USB_DEVICE(0x050D, 0x1105)}, /* Belkin - Edimax */ \
{USB_DEVICE(0x050D, 0x120A)}, /* Belkin - Edimax */ \
{USB_DEVICE(0x1668, 0x8102)}, /*  -  */ \
{USB_DEVICE(0x0BDA, 0xE194)}, /*  - Edimax */ \
{USB_DEVICE(0x0930, 0x0A0A)}, /* Toshiba */ \
	/****** 8192DU-WiFi Display Dongle ********/ \
{USB_DEVICE(0x2019, 0xAB2D)},/* Planex - Abocom ,5G dongle for WiFi Display */

%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
CLEAN="make clean"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
BUILT_MODULE_NAME="%{module}"
DEST_MODULE_LOCATION="/kernel/3rdparty/RTL8192DU"
AUTOINSTALL="yes"
EOF


%post -n %{name}
echo "blacklist rtlwifi" >> /etc/modprobe.d/blacklist
echo "blacklist rtl8192c_common" >> /etc/modprobe.d/blacklist
echo "blacklist rtl8192cu" >> /etc/modprobe.d/blacklist
echo "blacklist rtl8xxxu" >> /etc/modprobe.d/blacklist
/sbin/rmmod rtl8xxxu >/dev/null 2>&1
/sbin/rmmod rtlwifi >/dev/null 2>&1
/sbin/rmmod rtl8192c_common >/dev/null 2>&1
/sbin/rmmod rtl8192cu >/dev/null 2>&1

/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
/sbin/modprobe %{module} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{module}" >> /etc/modprobe.preload
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{module} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{module}/ d' /etc/modprobe.preload
sed -i '/rtlwifi/ d' /etc/modprobe.d/blacklist
sed -i '/rtl8192c_common/ d' /etc/modprobe.d/blacklist
sed -i '/rtl8192cu/ d' /etc/modprobe.d/blacklist
sed -i '/rtl8xxxu/ d' /etc/modprobe.d/blacklist
fi


%clean
%__rm -rf %{buildroot}

%files
%doc README.md
##CONTRIBUTORS.md LICENSE 
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}

%changelog
* Fri Aug 21 2020 onkelho <oh.quait at gmail.com> - 4.0.10-1pclos2020
- rebuild, lwfinger fixed kernel-5.8 and more

* Tue Feb 27 2018 onkelho <oh.quait at gmail.com> 1.0-4pclos2018
- update from 2018.02.26

* Sun Nov 04 2017 onkelho <oh.quait at gmail.com> 1.0-3pclos2017
- rebuild  --update from Jul07-2017 

* Mon Mar 13 2017 onkelho <oh.quait at gmail.com> 1.0-2pclos2017 
- rtl8192du: Fix build for API changes in kernel 4.11

* Sat Feb 18 2017 onkelho <oh.quait at gmail.com> 1.0-1pclos2017
- first build this version

